Summary: A D-Bus service which runs odd jobs on behalf of client applications
Name: oddjob
Version: 0.34.7
Release: 4%{?dist}
License: BSD
URL: https://pagure.io/oddjob
Source0: https://releases.pagure.org/oddjob/oddjob-%{version}.tar.gz

BuildRequires: make gcc
BuildRequires: libselinux-devel libxml2-devel
BuildRequires: dbus-devel >= 0.22 dbus-x11
BuildRequires: pam-devel pkgconfig
BuildRequires: cyrus-sasl-devel krb5-devel openldap-devel
BuildRequires: docbook-dtds xmlto systemd-units

Requires: dbus

Requires(post): systemd-units systemd-sysv psmisc
Requires(preun): systemd-units
Requires(postun): systemd-units
Requires(post): /sbin/chkconfig /sbin/service
Requires(preun): /sbin/chkconfig /sbin/service


%description
oddjob is a D-Bus service which performs particular tasks for clients which
connect to it and issue requests using the system-wide message bus.


%package mkhomedir
Summary: An oddjob helper which creates and populates home directories
Requires: oddjob = %{version}-%{release}
Requires(post): /usr/bin/dbus-send grep sed psmisc

%description mkhomedir
This package contains the oddjob helper which can be used by the
pam_oddjob_mkhomedir module to create a home directory for a user
at login-time.

%prep
%autosetup
sed -i "s/NAMESPACE=com.*$/NAMESPACE=com\.ocs/g" configure

%build
%configure \
  --disable-static \
  --enable-pie --enable-now \
  --with-selinux-acls \
  --with-selinux-labels \
  --without-python --enable-xml-docs --enable-compat-dtd \
  --disable-dependency-tracking \
  --enable-systemd --disable-sysvinit
%make_build

%install
rm -rf %{buildroot}
%make_install
rm -f %{buildroot}%{_libdir}/security/*.la
rm -f %{buildroot}%{_libdir}/security/*.a
rm -f %{buildroot}%{_libdir}/*.la


mkdir -p sample-install-root/sample/%{_sysconfdir}/dbus-1/system.d
mkdir -p sample-install-root/sample/%{_sysconfdir}/oddjobd.conf.d
mkdir -p sample-install-root/sample/%{_libdir}/oddjob
install -m 0644 sample/oddjobd-sample.conf sample-install-root/sample/%{_sysconfdir}/oddjobd.conf.d/
install -m 0644 sample/oddjob-sample.conf sample-install-root/sample/%{_sysconfdir}/dbus-1/system.d/
install -m 0755 sample/oddjob-sample.sh sample-install-root/sample/%{_libdir}/oddjob/

# Make sure these docs are not executable.
chmod -x src/reload src/mkhomedirfor src/mkmyhomedir

# Make sure timestamps match multilib pairs.
touch -r src/oddjobd-mkhomedir.conf.in %{buildroot}%{_sysconfdir}/oddjobd.conf.d/oddjobd-mkhomedir.conf
touch -r src/oddjob-mkhomedir.conf.in %{buildroot}%{_sysconfdir}/dbus-1/system.d/oddjob-mkhomedir.conf


%post
# install
if test $1 -eq 1 ; then
  killall -HUP dbus-daemon 2>&1 > /dev/null
fi

%systemd_post oddjobd.service

%postun
%systemd_postun_with_restart oddjobd.service
exit 0

%preun
%systemd_preun oddjobd.service
exit 0

%post mkhomedir
# install
if test $1 -eq 1 ; then
  killall -HUP dbus-daemon 2>&1 > /dev/null
fi
if [ -f /var/lock/subsys/oddjobd ] ; then
  /usr/bin/dbus-send --system --dest=com.ocs.oddjob /com/ocs/oddjob com.ocs.oddjob.reload
fi
exit 0


%files
%license COPYING
%doc *.dtd NEWS QUICKSTART doc/oddjob.html src/reload
%doc sample-install-root/sample
%{_bindir}/oddjob_request
%{_sbindir}/oddjobd
%dir %{_libexecdir}/oddjob
%{_libexecdir}/oddjob/sanity.sh
%dir %{_sysconfdir}/oddjob
%dir %{_sysconfdir}/oddjobd.conf.d
%config(noreplace) %{_sysconfdir}/oddjobd.conf.d/oddjobd-introspection.conf
%config(noreplace) %{_sysconfdir}/dbus-*/system.d/oddjob.conf
%config(noreplace) %{_sysconfdir}/oddjobd.conf
%{_unitdir}/oddjobd.service
%{_mandir}/*/oddjob.*
%{_mandir}/*/oddjob_request.*
%{_mandir}/*/oddjobd.*
%{_mandir}/*/oddjobd-introspection.*

%files mkhomedir
%doc src/mkhomedirfor src/mkmyhomedir
%dir %{_libexecdir}/oddjob
%{_libexecdir}/oddjob/mkhomedir
%{_libdir}/security/pam_oddjob_mkhomedir.so
%config(noreplace) %{_sysconfdir}/dbus-*/system.d/oddjob-mkhomedir.conf
%config(noreplace) %{_sysconfdir}/oddjobd.conf.d/oddjobd-mkhomedir.conf
%{_mandir}/*/pam_oddjob_mkhomedir.*
%{_mandir}/*/oddjob-mkhomedir.*
%{_mandir}/*/oddjobd-mkhomedir.*


%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.34.7-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.34.7-3
- Rebuilt for OpenCloudOS Stream 23

* Wed Dec 28 2022 Shuo Wang <abushwang@tencent.com> - 0.34.7-2
- update keyword in oddjob.conf

* Mon Jul 11 2022 Yi Lin <nilusyi@tencent.com> - 0.34.7-1
- package init.
